var REF_START = "<TABLE WIDTH=95% CELLSPACING=0 CELLPADDING=0 BORDER=0>"
var REF_END = "</body>"
var interval = 5*60*1000; //check for new content every 5 min...
var routeRoad = new Array()
var routeName = new Array()
var routeNumber = new Array()
var prefsShowing = false

routeRoad[0]="I-275"
routeName[0]="Between I-75 and Montgomery Road"
routeNumber[0]=8

routeRoad[1]="I-275"
routeName[1]="Between Montgomery Road and I-471"
routeNumber[1]=9

routeRoad[2]="I-275"
routeName[2]="Between Ronald Reagan Highway/SR126 and I-75"
routeNumber[2]=7

routeRoad[3]="I-275"
routeName[3]="Between Airport and Ronald Reagan Hwy/SR126"
routeNumber[3]=6

routeRoad[4]="I-275"
routeName[4]="Between Airport and I-471"
routeNumber[4]=10

routeRoad[5]="I-471"
routeName[5]="Between Downtown and I-275"
routeNumber[5]=12

routeRoad[6]="I-71"
routeName[6]="Between Kings Mills Road and Norwood Lateral/SR562"
routeNumber[6]=3

routeRoad[7]="I-71"
routeName[7]="Between Kings Mills Road and Norwood Lateral/SR562"
routeNumber[7]=4

routeRoad[8]="I-71"
routeName[8]="Between Ohio River and 71/75 Split"
routeNumber[8]=5

routeRoad[9]="I-74"
routeName[9]="Between I-75 and Indiana Border"
routeNumber[9]=11

routeRoad[10]="I-75"
routeName[10]="Between Norwood Lateral/SR562 and SR129"
routeNumber[10]=0

routeRoad[11]="I-75"
routeName[11]="Between Norwood Lateral/SR562 and Ohio River"
routeNumber[11]=1

routeRoad[12]="I-75"
routeName[12]="Between Ohio River and 71/75 Split"
routeNumber[12]=2

routeRoad[13]="Downtown"
routeName[13]="Downtown Cincinnati"
routeNumber[13]=17

routeRoad[13]="Downtown"
routeName[13]="Downtown Convington/Newport"
routeNumber[13]=18

routeRoad[14]="Norwood Lateral"
routeName[14]="Between I-75 and I-71"
routeNumber[14]=14

routeRoad[15]="Ronald Reagan Hwy/SR 126"
routeName[15]="Between Montgomery Road and I-275"
routeNumber[15]=13

routeRoad[16]="US 50"
routeName[16]="Between Downtown and Indiana Border"
routeNumber[16]=16

routeRoad[17]="US 50"
routeName[17]="Between I-275 at Clermont County and Downtown"
routeNumber[17]=15

var route=""

function showRoutes() {
	var prevRoute=""
	var link=""
	
	document.write("<b>Choose a route</b><p>")
	for(var i=0;i<routeRoad.length;i++)
	{
		if(routeRoad[i]!=prevRoute) {
			if(prevRoute) {
				document.write("<br>")
			}
			document.write("<b>"+routeRoad[i]+"</b><br>")
			prevRoute=routeRoad[i]
		}
		link="<a href=\"javascript: setRoute("+routeNumber[i]+")\">"+routeName[i]+"</a><br>"
		document.write(link)
	}
}

function sendRequest(callback) {
	document.getElementById("content").innerHTML="Loading..."
	if(myroute>=0) {
		var url = "http://www.artimis.org/cgi/segview.cgi?route="+myroute
	
		req = new XMLHttpRequest()
		req.onreadystatechange = callback
		req.open("GET", url, true)
		req.send(null)
	}
}

function sendMyCity() {
	var name=document.getElementById("name").value.replace("_","+")
	var email=document.getElementById("email").value.replace("_","+")
	var city=document.getElementById("thecity").value.replace("_","+")
	var url=document.getElementById("url").value
	
	var site="http://maccrafters.com/artimis/cityRequest.php?name="+name+"&email="+email+"&city="+city+"&url="+url
	
	req = new XMLHttpRequest()
	req.onreadystatechange = handleSubmitResponse
	req.open("GET", site, true)
	req.send(null)
}

function checkMyCity() {
	if(!document.getElementById("name").value || !document.getElementById("thecity").value || !document.getElementById("url").value) {
		document.getElementById("error").style.visibility="visible"
	} else {
		document.getElementById("error").style.visibility="hidden"
		sendMyCity()
	}
}

function handleResponse() {
	if (req.readyState == 4) {
		var response = ""
		if (req.status == 200) {
			document.getElementById("content").innerHTML=parseResponse(req.responseText)
		} else {
			error("No response from server.")
		}
	}
}

function handleSubmitResponse() {
	if (req.readyState == 4) {
		var response = ""
		document.getElementById("success").style.visibility="visible"
		document.getElementById("mycity").style.visibility="hidden"
		if (req.status == 200) {
			
		} else {
			document.getElementById("success").innerHTML="No reponse from server."
		}
	}
}
	
function error(message) {
	document.getElementById("content").innerHTML="<font color=#ff0000>"+message
}

function setup() {
	if (window.widget) {
		widget.onshow = onshow;
		widget.onhide = onhide;
		myroute = getPrefVal("route","")
	}
}

function showPrefs() {
	var front = document.getElementById("front")
	var back = document.getElementById("back")
	
	if (window.widget)
		widget.prepareForTransition("ToBack");
	   
	front.style.visibility="hidden"
	back.style.visibility="visible"
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
}

function hidePrefs() {
	
	var front = document.getElementById("front")
	var back = document.getElementById("back")
	
	if (window.widget)
		widget.prepareForTransition("ToFront");
	
	front.style.visibility="visible";
	back.style.visibility="hidden"
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
}

//get the pref val for a specified key, setting it to passed value if it doesn't exist    
function getPrefVal(key, value) {
	var str = widget.preferenceForKey(key);
	if (str == null) {
		str = widget.preferenceForKey(key);
		if (str == null) {
			str =  value;
		}
	}
	setPrefVal(key, str);
	return str;
}

//Set a preference, globally and for this instance
function setPrefVal(key, value) {
	widget.setPreferenceForKey(value, key)
	return true;
}

function onshow() {
	myroute=getPrefVal("route","")
	sendRequest(handleResponse)
}

function onhide () {
}

function parseResponse(text) {
	var reference = text.substring(text.indexOf(REF_START), text.indexOf(REF_END));
	
	reference = reference.replace("</body>","")
	reference = reference.replace("/images","images")
	return(reference)
}

function enterRollie(event) {
	document.getElementById("rollie").style.visibility="visible"
}

function exitRollie(event) {
	document.getElementById("rollie").style.visibility="hidden"
}

function setRoute(rte) {
	setPrefVal("route",rte)
	myroute=rte
	hidePrefs()
	sendRequest(handleResponse)
}

function checkRoute() {
	if(!myroute) {
		showPrefs()
	}
}

function swapImage(id,src) {
	document.getElementById(id).src="images/"+src
}

function showRoutesTab() {
	document.getElementById("mycity").style.visibility="hidden"
	document.getElementById("success").style.visibility="hidden"
	document.getElementById("myroutes").style.visibility="visible"
	document.getElementById("routes").src="images/Routes-down.png"
	document.getElementById("city").src="images/My_City.png"
}

function showCityTab() {
	document.getElementById("mycity").style.visibility="visible"
	document.getElementById("success").style.visibility="hidden"
	document.getElementById("myroutes").style.visibility="hidden"
	document.getElementById("routes").src="images/Routes.png"
	document.getElementById("city").src="images/My_City-down.png"
}
